using System;
using System.Data;
using MySql.Data.MySqlClient;

namespace	ConsoleApplication1
{
  ///	<summary>
  ///	Summary	description	for	Class1.
  ///	</summary>
  class	Class1
  {
	  private static void AddBlobToMySQL( string _strConnectionString, string
		  _strDatabaseName, byte[] _arrBytes )
	  {
		  MySqlConnection     mysqlConnection;
		  MySqlCommand        mysqlCommand;
		  MySqlTransaction    mysqlTransaction;
            
		  mysqlConnection = null;
		  mysqlCommand = null;
		  mysqlTransaction = null;

		  try
		  {
			  // Create the MySQL Connection:
			  mysqlConnection = new MySqlConnection( _strConnectionString );
                
			  // Open the connection:
			  mysqlConnection.Open( );
			  mysqlCommand = mysqlConnection.CreateCommand( );
            
			  // Begin the Transaction:
			  mysqlTransaction = mysqlConnection.BeginTransaction( );

			  // Set the connection
			  mysqlCommand.Connection = mysqlConnection;
			  mysqlCommand.Transaction = mysqlTransaction;
                
			  // Add the query:
			  mysqlCommand.Parameters.Add( "?", MySqlDbType.LongBlob,
				  _arrBytes.Length ).Value = _arrBytes;
			  mysqlCommand.CommandText = string.Format( "INSERT {0} (Data, Size) VALUES( ?, {1})", _strDatabaseName, _arrBytes.Length );
              // execute the command:
			  mysqlCommand.ExecuteNonQuery( );

		  // commit the transaction:
		  mysqlTransaction.Commit( );
	  }
		  catch( MySqlException exception )
		  {
			  try
			  {
				  if ( mysqlTransaction != null )
					  mysqlTransaction.Rollback();
			  }
			  catch ( MySqlException ex )
			  {
				  throw ex;
			  }
			  catch ( System.Exception ex )
			  {
				  throw ex;
			  }

			  throw exception;
		  }
		  catch( System.Exception exception )
		  {
			  try
			  {
				  if ( mysqlTransaction != null )
					  mysqlTransaction.Rollback();
			  }
			  catch ( MySqlException ex )
			  {
				  throw ex;
			  }
			  catch ( System.Exception ex )
			  {
				  throw ex;
			  }
                
			  throw exception;
		  }
		  finally 
		  {
			  if ( mysqlConnection != null && mysqlConnection.State ==
				  System.Data.ConnectionState.Open )
				  mysqlConnection.Close( );
		  }
	  }
        
	  /// <summary>
	  /// The main entry point for the application.
	  /// </summary>
	  [STAThread]
	  static void Main( string[] args )
	  {
		  string  strTableName;
		  string  strConnectionString;
		  byte[]  arrData;

		  // To run this sample you have to make sure you have created a
		  // Catalog named 'mysqltest' and the following Table:
															   //CREATE TABLE `mysqltest`.`TestTable` (
															   //  `ID` INTEGER UNSIGNED AUTO_INCREMENT,
															   //  `Data` LONGBLOB NOT NULL DEFAULT '',
															   //  `Size` INTEGER UNSIGNED NOT NULL DEFAULT 0,
															   //  PRIMARY KEY(`ID`)
															   //)
															   //ENGINE = InnoDB;
            

															   // Initialsation:
															   strTableName = "TestTable";
		  strConnectionString = string.Format(
			  "server=localhost;database=mysqltest;uid=root;pwd=;" );
            
		  try
		  {
			  // Fails due to MySQL Server max_allowed_packet size:
			  arrData = new byte[ 1048576 ];
			  AddBlobToMySQL( strConnectionString, strTableName, arrData );
		  }
		  catch ( System.Exception exception )
		  {
			  Console.WriteLine( exception.Message );
		  }

		  try
		  {
			  // This should succeed:
			  arrData = new byte[ 20 ];
			  AddBlobToMySQL( strConnectionString, strTableName, arrData );
		  }
		  catch ( System.Exception exception )
		  {
			  Console.WriteLine( exception.Message );
		  }
		  Console.ReadLine( );
	  }
  }
}
